/*!
        @file    $Id:: source.h #$

        @brief

        @author  Tatsumi Aoyama <aoym@post.kek.jp> (aoym)
                 $LastChangedBy: matufuru $

        @date    $LastChangedDate:: 2014-06-02 23:54:18 #$

        @version $LastChangedRevision: 1054 $
*/

#ifndef SOURCE_INCLUDED
#define SOURCE_INCLUDED

#include <valarray>
#include "defs.h"
#include "commonParameters.h"
#include "field.h"
#include "bridgeIO.h"

//! Base class of sources for a linear solver.

/*!
    (Coding history will be recovered from trac.)
    Parameters_Source_All is implemented for source_selector.
                                      [2 Feb 2013 Y.Namekawa]
 */

class Source
{
 protected:
  Bridge::VerboseLevel m_vl;

 public:
  Source() {}
  virtual ~Source() {}

  void set_parameter_verboselevel(const Bridge::VerboseLevel vl) { m_vl = vl; }

  virtual void set(Field&, int) = 0;

};
#endif /* SOURCE_INCLUDED */
