/*!
        @file    $Id:: threadManager_OpenMP.cpp #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru) 
                 $LastChangedBy: matufuru $

        @date    $LastChangedDate:: 2013-01-04 18:22:56 #$

        @version $LastChangedRevision: 820 $
*/

#include "threadManager_OpenMP.h"


#include "communicator.h"
#include "bridgeIO.h"
using Bridge::vout;

// These are stub routine when OpenMP is not used.
//                                          [11 Mar 2014 H.Matsufuru]
//====================================================================
// initialization of static member variables.

int ThreadManager_OpenMP::m_Nthread = 0;
Bridge::VerboseLevel ThreadManager_OpenMP::m_vl = Bridge::CRUCIAL;
valarray<double> ThreadManager_OpenMP::m_darray_reduction(0);

//====================================================================
void ThreadManager_OpenMP::init(int nthread){

  m_vl = CommonParameters::Vlevel();

  vout.general(m_vl, "ThreadManager_OpenMP being setup.\n");

  m_Nthread = 1;
  vout.crucial(m_vl, "  Number of thread = %d\n", m_Nthread);
  vout.crucial(m_vl, "  OpenMP not used.\n");

}

//====================================================================
void ThreadManager_OpenMP::finalize(){

  vout.general(m_vl, "Thread manager says good-bye.\n");

}

//====================================================================
int ThreadManager_OpenMP::get_num_threads(){

  return 1;

}

//====================================================================
int ThreadManager_OpenMP::get_thread_id(){

  return 0;

}

//====================================================================
void ThreadManager_OpenMP::wait(){

}

//====================================================================
void ThreadManager_OpenMP::barrier(int nth){

}

//====================================================================
void ThreadManager_OpenMP::sync_barrier_all(){

  Communicator::sync();

}
//====================================================================
void ThreadManager_OpenMP::reduce_sum_global(double& a,
                                       const int ith, const int nth){

    a = Communicator::reduce_sum(a);

}

//====================================================================
//============================================================END=====
