/*!
        @file    $Id:: solver.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: matufuru $

        @date    $LastChangedDate:: 2014-06-02 23:54:18 #$

        @version $LastChangedRevision: 1054 $
*/


#ifndef SOLVER_INCLUDED
#define SOLVER_INCLUDED

#include "defs.h"
#include "commonParameters.h"
#include "bridgeIO.h"

#include "fopr.h"
#include "field.h"

//! Base class for linear solver class family.

/*!
                               [28 Dec 2011 H.Matsufuru]
 */

class Solver
{
 public:

  Solver()
    : m_vl(CommonParameters::Vlevel()) {}

  virtual ~Solver() {}

  void set_parameter_verboselevel(const Bridge::VerboseLevel vl) { m_vl = vl; }

  virtual void set_parameters(const int Niter, const double Stop_cond) = 0;

  virtual void solve(Field& solution, const Field& source,
                     int& Nconv, double& diff) = 0;

  virtual Fopr *get_fopr() = 0;

 protected:

  Bridge::VerboseLevel m_vl;

};
#endif
